
typedef struct Pe Pe;
struct Pe {
	Biobuf *bp;
	char *file;
};

typedef struct Namval Namval;
struct Namval {
	vlong val;
	char *str;
};

typedef struct Prfmt Prfmt;
struct Prfmt {
	int type;
	int sz;
	Namval *tab;
	char *name;
};

enum {			// types of pr() format
	Dec,		// decimal integer
	Hex,		// hex integer
	Str,		// string
	Tab,		// table of values to match
	Time,		// secs since 1/1/70
	Skip,		// ignore this field
	Mask		// bitmask of flags to test
};

/*
 * known sections.
 *	.text		code
 *	CODE		Borland code
 *	.data		initialised data
 *	DATA		Borland data
 *	.bss		uninitialised data
 *	.rdata		readonly data for code
 *	.rsrc		resources
 *	.idata		imports
 *	.edata		exports
 *	.reloc		relocations
 *	.debug		debug
 */


extern vlong rint(Pe *, int);
extern int rmem(Pe *, void *, int);
extern int skip(Pe *, int);
extern char *lookup(Namval *nv, int val);
extern void pr(Pe *, Prfmt *);
extern void xd(Pe *, int addr, int n);

extern Prfmt Doshdr[];
extern Prfmt Imagehdr[];
extern Prfmt Coffhdr32[];
extern Prfmt Coffhdr64[];
extern Prfmt Nthdr32[];
extern Prfmt Nthdr64[];
extern Prfmt Sechdr[];
extern char *Direntries[];
extern Prfmt Exporthdr[];
extern Prfmt Importhdr[];

extern Namval Symclass[];
extern Namval Symbase[];
extern Namval Symcomp[];

extern Biobuf *op;
